//*****************************************************************
//* Ce fichier et le fichier lib.cpp contienent les structures et * 
//* les fonctions  que vous serez amener à utiliser. Vous n'avez  * 
//* normalement pas besoin de modifier ces fichiers.              *
//***************************************************************** 

#ifndef LIBRAIRIE_H
#define LIBRAIRIE_H

#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <SDL/SDL.h>


using namespace std;

typedef unsigned short int usint;

//************ SDL *************//

void sdl_init();
extern int h,w;

//********** DESSIN ***********//

int arrondi(float f);
int abs(int i);

class Point{
 public:
  int x,y;
  Point();
  Point(int,int);
  friend ostream& operator<<(ostream& os,const Point& P);
};

class Couleur{
 public:
  unsigned char red,green,blue;
  Couleur(unsigned char r,unsigned char g,unsigned char b);
  Couleur(unsigned char g);
};

class Ecran_SDL{
 private:
  SDL_Surface *sdl_screen;
 public:
  Ecran_SDL();
  Ecran_SDL(int w,int h);
  void effacer();
  void rafraichir();
  void dessine_point(Point P,Couleur c);
  void dessine_ligne(Point A,Point B,Couleur c);
  void dessine_grille(int taille,Couleur C);
  void dessine_point_sur_grille(Point P,int taille,Couleur C);
  
};


//********* EVENEMENTS ***********//

typedef SDL_Event Evenement;

Evenement attendre_evenement();
bool est_quitter(Evenement& e);
bool est_bouton_souris_enfoncer(Evenement& e);
bool est_bouton_souris_relacher(Evenement& e);
bool est_deplacement_souris(Evenement& e);
bool est_touche_enfoncer(Evenement& e);
Point lire_position_action_bouton(Evenement& e);
Point lire_position_souris(Evenement& e);
SDLKey lire_touche(Evenement& e);
void deplace_souris(Point P);
#endif
