#include "lib.h"

Point milieu(Point A,Point B){
  return Point((A.x+B.x)/2,(A.y+B.y)/2);
}

void foo(Point A,Point B,Ecran_SDL&e, Couleur& col){
  float n=10;
  Point P;
  float lambda;
  for(float i=0;i<=n;++i){
    lambda=i/n;
    P.x=arrondi(lambda*A.x+(1-lambda)*B.x);
    P.y=arrondi(lambda*A.y+(1-lambda)*B.y);
    e.dessine_point(P,col);
  }
}

void convex_hull3(Point A,Point B,Point C,Ecran_SDL&e,Couleur& col){
  float n=100;
  float d=1/n;
  Point P;
  float l1,l2;
  for(l1=0;l1<=1;l1+=d){
    for(l2=0;l2<=1-l1;l2+=d){
      P.x=arrondi(l1*A.x+l2*B.x+(1-l1-l2)*C.x);
      P.y=arrondi(l1*A.y+l2*B.y+(1-l1-l2)*C.y);
      e.dessine_point(P,col);
    }
  }
}

int main(int argc,char* argv[]){ 

  //Initiation de SDL
  sdl_init();
  Evenement e;
  bool continuer=true;

  //Creation d'un ecran de taille 640x480
  Ecran_SDL ecran(640,480);
  Couleur blanc(255);//blanc
  Couleur gris(128);//bleu
  Couleur vert(0,255,0);//vert

  
  //** Nombre de point necessaire avant dessin (ex. 2 pour milieu)
  usint needed_points=3;
  //***************************************************************

  usint nb_points=0;
  Point* Ps=new Point[needed_points];
  Point P;

  ecran.rafraichir();
  while(continuer){
    e=attendre_evenement();
    if(est_quitter(e)){
      continuer=false;
    }
    else if(est_bouton_souris_enfoncer(e)){
      P=lire_position_action_bouton(e);
      ecran.dessine_point(P,vert);
      Ps[nb_points]=P;
      ++nb_points;
      if(nb_points==needed_points){

	//** appel de la fonction de dessin
	//	P=milieu(Ps[0],Ps[1]);
	//ecran.dessine_point(P,blanc);
	//foo(Ps[0],Ps[1],ecran,blanc);
	convex_hull3(Ps[0],Ps[1],Ps[2],ecran,blanc);
//*************************************


	nb_points=0;
	for(int i=0;i<needed_points;++i){
	  ecran.dessine_point(Ps[i],vert);
 	}
      }
      ecran.rafraichir();
    }
    else if(est_touche_enfoncer(e)){
      switch(lire_touche(e)){
      case SDLK_e:
	nb_points=0;
	ecran.effacer();
	ecran.rafraichir();
	break;
      case SDLK_a:
      case SDLK_ESCAPE:
	continuer=false;
	break;
      default:
	break;
      }
    }
  }
  return EXIT_SUCCESS;
}

